#ifndef FUNCLASS_HH
#define FUNCLASS_HH

template <typename T>
class FunClass {
public:
  typedef T valueType ; // valueType is an alias for T
private:
  FunClass( FunClass const & ) ; // block the copy constructor
  FunClass const & operator = ( FunClass const & ) ; // block the copy operator
public:
  FunClass() {}
  virtual T operator () ( T const & val ) const = 0 ;
  virtual T D( T const & val ) const = 0 ; // make class pure virtual
} ;

#endif
