#ifndef NC_FUNCTION_HH
#define NC_FUNCTION_HH

#include "funclass.hh"

template <typename T>
class NC_Function : FunClass<T> {
public:
  NC_Function() : FunClass<T>() {}
  NC_Function( T const & a ) : FunClass<T>() {}
  
  virtual T operator () ( T const & x ) const {
    return atan(x) ;
  }
  virtual T D( T const & x ) const {
    return 1/(1+x*x);
  }
} ;

#endif
