#ifndef MYFUNCTION_HH
#define MYFUNCTION_HH

#include "funclass.hh"

template <typename T>
class MyFunction : FunClass<T> {
  T avalue ;
public:
  MyFunction() : FunClass<T>(), avalue(2) {}
  MyFunction( T const & a ) : FunClass<T>(), avalue(a) {}
  
  virtual T operator () ( T const & x ) const {
    return x*x-avalue ;
  }
  virtual T D( T const & x ) const {
    return 2*x ;
  }
} ;

#endif
